package Cache_mgr; # singleton

#
# The Cache_mgr will store upto BOUND iml documents in it.
# When the number of crosses BOUND, it will expunge the  least recently
# used document to make space.
#
# Currently, the solution is costly... but who cares! We will rewrite
# it at some stage if this is a bottleneck...
#


# data str:
#         array (i0,i1,i2,...,in)
#         hash  (i0, 0, i1, 1,...in, n);

@Cache_mgr=();
%Cache_mgr=();

my $BOUND=32;
sub add{
	my $self=shift;
	my $item=shift;
	if ($self->{$item}) {
		my $pos = $self->{$item};
		if ($pos) {# move to front
			my $i=0;
			for ($i=0;$i<$pos;$i++) {#increase rank of items
				my $entry=$self->[$i];
				$self->{$entry}++;
			}
			splice @$self, $pos,1;
			unshift @$self, $item;
			$self->{$item}=0;
		}

	}else {
		my $i=0;
		for (@$self) {
			$self->{$_}++;
			$i++;
		}
		unshift @$self,$item;
		$self->{$item}=0;
		if ($i==$BOUND) {
			my $last= pop @$self;
			delete $self->{$last};
		}
	}
}

sub exist {
	my $self=shift;
	my $item= shift;

	if (exists $self->{$item}) {
		return 1
	}
	return 0
}

sub show {
	my $self=shift;
	print "[ @$self ]\n";
	for (keys %$self) {
		print $_," => ", $self->{$_},"\n";
	}
}

1;
