package Schedule; # Singleton

use Tk qw/:eventtypes/;
use Tk qw(DoOneEvent);
#
# data str: [[items, ...], total_length]
#

$|=1;
@Schedule=([], 0);
my $RR=0; # RR=1 => Round Robin;  RR=0 => FIFO 

sub job {
	my $self=shift;
	my $obj=shift;
	my ($arr,$counter)=@$self;
        #print "--->  schedule ...\n";
#        if($obj->is_scheduled){print "---->  dup !!!\n";return}        
        $obj->set_schedule;
        push @$arr, $obj;
	$self->[1]=$counter+1;
        UI->activate_stop;
}

sub trace {
	my $self=shift;
	my ($arr,$counter)=@$self;
	print "Scheduler trace: [ @$arr ][ $counter]\n";
}

sub scheduler {
        my $self=shift;
        while(1){
                DoOneEvent(DONT_WAIT);
                while(!$self->[1]){
                        DoOneEvent(0)
                }
                #Schedule->trace;
                my ($arr,$counter)=@$self;
                DoOneEvent(DONT_WAIT);                
                my $first=shift @$arr;
                #print "\n\tSCHEDULED:: $first\n";
                DoOneEvent(DONT_WAIT);
                if(!$first->is_scheduled){                   
                        print "<<de_schedule\n";
                        $self->[1]=$counter-1;
                        if($counter==1){UI->deactivate_stop}
                        #Schedule->trace;
                        #print "de_schedule>>\n";                        
                        next                        
                }
                if($first->closed){
                        #print "<<in closed\n";
                        $first->clear_schedule;
                        $self->[1]=$counter-1;
                        if($counter==1){UI->deactivate_stop}
                        $first->cleanup;
			DoOneEvent(DONT_WAIT);
			DoOneEvent(DONT_WAIT);
			DoOneEvent(DONT_WAIT);			
                        #Schedule->trace;
                        #print "in closed>>\n";                        
                        next
                }
                DoOneEvent(DONT_WAIT);
                if($RR){push @$arr, $first}else{unshift @$arr, $first}
                $first->run;                
        }
}

1;
